﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using Syncfusion.Data;
using Syncfusion.Data.Extensions;
using Syncfusion.UI.Xaml.Controls.DataPager;
using System.Windows.Interactivity;
using FilteringDemo.ViewModel;

namespace FilteringDemo.Helpers
{
    public class OnDemandLoadBehavior : Behavior<MainWindow>
    {
        EmployeeInfoViewModel viewmodel;

        protected override void OnAttached()
        {
            viewmodel = AssociatedObject.DataContext as EmployeeInfoViewModel;
            AssociatedObject.Loaded += OnAssociateObjectLoad;
            (AssociatedObject.DataContext as EmployeeInfoViewModel).FilterChanged += OnFilterChanged;
            empsource = viewmodel.EmployeeDetails;
        }

        IEnumerable<Employees> empsource;
        private void OnFilterChanged()
        {
            empsource = viewmodel.EmployeeDetails.Where(emp => viewmodel.FilerRecords(emp));
            var totalcount = empsource.Count();
            var pagecount = 0;
            if (totalcount < this.AssociatedObject.SfDataPager.PageSize)
                pagecount = 1;
            else
                pagecount = totalcount / this.AssociatedObject.SfDataPager.PageSize;

            if (this.AssociatedObject.SfDataPager.PageCount != pagecount)
                this.AssociatedObject.SfDataPager.PageCount = pagecount;

            (this.AssociatedObject.sfGrid.View as PagedCollectionView).ResetCache();
            (this.AssociatedObject.sfGrid.View as PagedCollectionView).ResetCacheForPage(this.AssociatedObject.SfDataPager.PageIndex);
            (this.AssociatedObject.sfGrid.View as PagedCollectionView).MoveToFirstPage();
        }

        void OnAssociateObjectLoad(object sender, System.Windows.RoutedEventArgs e)
        {
            AssociatedObject.SfDataPager.OnDemandLoading += OnDemandLoading;
            //AssociatedObject.sfGrid.SortColumnsChanging += OnSortColimnChanging;
            AssociatedObject.SfDataPager.MoveToFirstPage();
        }

        void OnDemandLoading(object sender, OnDemandLoadingEventArgs args)
        {
            AssociatedObject.SfDataPager.LoadDynamicItems(args.StartIndex, empsource.Skip(args.StartIndex).Take(args.PageSize).ToList());
        }

        protected override void OnDetaching()
        {
            AssociatedObject.Loaded -= OnAssociateObjectLoad;
            AssociatedObject.SfDataPager.OnDemandLoading -= OnDemandLoading;
            //AssociatedObject.sfGrid.SortColumnsChanging -= OnSortColimnChanging;
        }
        
        /*
        private void OnSortColimnChanging(object sender, Syncfusion.UI.Xaml.Grid.GridSortColumnsChangingEventArgs e)
        {
            (AssociatedObject.SfDataPager.PagedSource as PagedCollectionView).ResetCache();
            (AssociatedObject.SfDataPager.PagedSource as PagedCollectionView).ResetCacheForPage(AssociatedObject.SfDataPager.PageIndex);
            if (e.Action == NotifyCollectionChangedAction.Add || e.Action == NotifyCollectionChangedAction.Replace)
            {
                var sortDesc = e.AddedItems[0];
                if (sortDesc.SortDirection == ListSortDirection.Ascending)
                {
                    _source = _source.OfQueryable().AsQueryable().OrderBy(sortDesc.ColumnName).Cast<Employees>().ToList();
                }
                else
                {
                    _source =
                        _source.OfQueryable()
                              .AsQueryable()
                              .OrderByDescending(sortDesc.ColumnName)
                              .Cast<Employees>()
                              .ToList();
                }
                AssociatedObject.SfDataPager.MoveToPage(AssociatedObject.SfDataPager.PageIndex);
            }
        }
        */

    }
}
